<template>
  <div>
    <div class="body" :style="{height:mainHeight+'px'}">
      <div class="bodyTopButtonGroup">
        <el-button
          v-waves
          :style="{visibility:$buttoncode.includes('Add')?'':'hidden'}"
          type="primary"
          icon="el-icon-circle-plus-outline"
          @click="add('add')"
        >新增</el-button>
      </div>

      <div class="bodyTopFormGroup">
        <el-form
          ref="form"
          :model="form"
          label-width="100px"
          inline
          style="display: flex;"
        >
          <div class="elForm">
            <el-form-item label="菜单名称" style=" display: flex;">
              <el-input v-model="form.rightname" placeholder="请输入" style="width: 200px" />
            </el-form-item>
            <el-form-item label="固定字符" style=" display: flex;">
              <el-input v-model="form.prefix" placeholder="请输入" style="width: 200px" />
            </el-form-item>

          </div>
          <div
            class="bodySearchReset"
            :style="{marginLeft:$store.state.app.sidebar.opened? $store.state.settings.menuIsHorizontal?'15%':'3%':'10%'}"
          >
            <el-button v-waves type="primary" icon="el-icon-search" @click="getEncodingRules">查询</el-button>
            <el-button v-waves type="info" icon="el-icon-refresh" @click="reset">重置</el-button>
          </div>
        </el-form>
        <div
          class="bodyTopFormExpand"
          style="height:5px"
        >
          <!--          <svg-icon-->
          <!--            v-show="mouseHoverType==='mouseout'"-->
          <!--            style="cursor: pointer"-->
          <!--            :icon-class="!isExpandForm?'doubleDown3':'doubleUp3'"-->
          <!--            @mouseenter="mouseHoverType=$event.type"-->
          <!--          />-->
          <!--          <svg-icon-->
          <!--            v-show="mouseHoverType==='mouseenter'"-->
          <!--            style="cursor: pointer"-->
          <!--            :icon-class="!isExpandForm?'doubleDown':'doubleUp'"-->
          <!--            @click="isExpandForm=!isExpandForm"-->
          <!--            @mouseout="mouseHoverType=$event.type"-->
          <!--          />-->
        </div>
      </div>

      <div class="elTableDiv">

        <el-table
          ref="tableDataRef"
          class="tableFixed"
          :data="tableData"
          :height="isExpandForm?tableHeight:(tableHeight+40)+'px'"
          border
          row-class-name="custom-row"
          :style="{width: 100+'%',height:isExpandForm?tableHeight:(tableHeight+40)+'px',}"
          highlight-current-row
          :header-cell-style="this.$headerCellStyle"
          :cell-style="this.$cellStyle"
          @sort-change="sortChange"
        >
          <el-table-column
            prop="rowNum"
            width="50"
            fixed
            label="序号"
          />
          <el-table-column
            prop="menucode"
            label="菜单编码"
            sortable="custom"
          />
          <el-table-column
            prop="menuname"
            label="菜单名称"
            sortable="custom"
          />
          <el-table-column
            prop="Type"
            label="菜单类型"
            sortable="custom"
          />
          <el-table-column
            prop="prefix"
            label="固定字符"
            sortable="custom"
          />
          <el-table-column
            prop="filingdate"
            label="编码格式"
            sortable="custom"
          />
          <el-table-column
            prop="incbit"
            label="自增位数"
            sortable="custom"
          />
          <el-table-column
            prop="value"
            label="流水号"
            width="160"
            sortable="custom"
          />
          <el-table-column
            v-if="$buttoncode.toString().length"
            label="操作"
            width="120"
            fixed="right"
          >
            <template slot-scope="{row}">
              <div class="operationClass">
                <el-tooltip class="item" effect="dark" content="编辑" placement="top">
                  <i
                    class="el-icon-edit-outline"
                    :style="{color:$store.state.settings.theme,display:$buttoncode.includes('Update')?'':'none'}"
                    @click="edit('edit',row)"
                  />
                </el-tooltip>
                <el-tooltip v-del-tab-index class="item" effect="dark" content="删除" placement="top">
                  <i
                    class="el-icon-delete"
                    :style="{color:$store.state.settings.theme,display:$buttoncode.includes('Delete')?'':'none'}"
                    @click="del(row)"
                  />
                </el-tooltip>
              </div>
            </template>
          </el-table-column>
        </el-table>
      </div>
      <!--分页-->
      <pagination
        :total="total"
        :page.sync="form.page"
        :limit.sync="form.rows"
        align="right"
        layout="total,prev, pager, next,sizes"
        popper-class="select_bottom"
        @pagination="getEncodingRules"
      />
    </div>

    <el-dialog
      v-el-drag-dialog
      :title="operation==='add'?'新增':'编辑'"
      :visible.sync="dialogVisible"
      width="800px"
      :close-on-click-modal="false"
      top="15vh"
      @closed="handleClose"
      @close="handleClose"
    >
      <el-form
        ref="dialogForm"
        inline
        :rules="dialogFormRules"
        style="display: flex;flex-direction: column"
        :model="dialogForm"
        label-width="80px"
      >
        <el-form-item label="菜单类型" required>
          <el-radio-group v-model="dialogForm.type" @change="radioChange">
            <el-radio label="PC" name="PC" />
            <el-radio label="APP" name="APP" />
          </el-radio-group>
        </el-form-item>
        <el-form-item label="菜单名称" required>
          <el-cascader
            ref="cascader"
            :options="menuOptions"
            filterable
            :props="defaultProps"
            :show-all-levels="false"
          />
        </el-form-item>
        <el-form-item label="固定字符" prop="prefix">
          <el-input v-model="dialogForm.prefix" style="width: 200px" />
        </el-form-item>
        <el-form-item prop="filingdate" label="编码格式">
          <el-select
            v-model="dialogForm.filingdate"
            style="width: 200px"
            placeholder="请选择"
            :popper-append-to-body="false"
          >
            <el-option
              v-for="item in dateType"
              :key="item.code"
              :label="item.name"
              :value="item.code"
            />
          </el-select>
        </el-form-item>

        <el-form-item label="自增位数" prop="incbit" required>
          <el-input v-model="dialogForm.incbit" oninput="value=value.replace(/[^0-9]/g,'')" style="width: 200px" />
        </el-form-item>

        <el-form-item label="编码预览">
          {{ encodingPre }}
          <!--          <el-input v-model="dialogForm.OrgName" style="width: 200px" />-->
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <div class="footerButton">
          <el-button v-waves @click="dialogVisibleCancel">取 消</el-button>
          <el-button
            v-waves
            type="primary"
            :loading="$store.state.app.buttonIsDisabled"
            :disabled="$store.state.app.buttonIsDisabled"
            @click="dialogVisibleConfirm"
          >确 定</el-button>
        </div>
      </span>
    </el-dialog>

  </div>
</template>

<script>
import Pagination from '@/components/Pagination'
import { getCookie } from '@/utils/auth'
import { validateCode } from '@/utils/global'
import elDragDialog from '@/directive/el-drag-dialog'
import waves from '@/directive/waves'
import { CodeMenuSelect, DeleteEncodingRules, EncodingRules, SaveEncodingRules } from '@/api/systemSetting'
import arrayToTree from 'array-to-tree'

export default {
  name: 'ReportList',
  components: {
    Pagination
  },
  directives: { elDragDialog, waves },
  data() {
    return {
      isExpandForm: false,
      mainHeight: 0,
      tableHeight: 0,
      form: {
        rightname: '', // 编码名称
        prefix: '', // 固定字符
        prop: 'lm_date', // 排序字段
        order: 'desc', // 排序字段
        page: 1, // 第几页
        rows: 20 // 每页多少条
      },
      total: 10,
      tableData: [],
      dialogVisible: false,
      dialogForm: {
        type: 'PC', // 菜单类型
        rightcode: '', // 菜单编码
        rightname: '', // 菜单名称
        incbit: '1', // 自增位数
        filingdate: '', // 编码格式
        prefix: ''// 固定字符
      },
      encodingPre: '', // 编码预览
      dateType: [
        { name: '年月日', code: '年月日' },
        { name: '年月', code: '年月' },
        { name: '年', code: '年' }
      ],
      menuOptionsAll: [],
      menuOptions: [],
      defaultProps: {
        expandTrigger: 'hover',
        value: 'menucode',
        label: 'menuname'
      },
      operation: '',
      dialogFormRules: {
        prefix: [
          { required: true, message: '请输入固定字符', trigger: ['blur', 'change'] }
        ],
        // OrgCode: [
        //   { required: true, validator: validateCode, trigger: ['blur', 'change'] }
        // ],
        filingdate: [
          { required: true, message: '请选择编码格式', trigger: ['blur', 'change'] }
        ],
        incbit: [
          { required: true, message: '请输入自增位数', trigger: ['blur', 'change'] }
        ]

      }
    }
  },
  watch: {
    dialogForm: {
      handler(newValue, oldValue) {
        const date = new Date()
        let newDate = ''
        if (newValue.filingdate === '年月日') {
          newDate = date.getFullYear().toString().substring(2, 4) + '' + (date.getMonth() + 1 + '').padStart(2, '0') + '' + (date.getDate() + '').padStart(2, '0')
        } else if (newValue.filingdate === '年月') {
          newDate = date.getFullYear().toString().substring(2, 4) + '' + (date.getMonth() + 1 + '').padStart(2, '0')
        } else if (newValue.filingdate === '年') {
          newDate = date.getFullYear().toString().substring(2, 4) + ''
        }
        this.encodingPre = newValue.prefix + '' + newDate + '' + (1 + '').padStart(newValue.incbit, '0')
      },
      immediate: true,
      deep: true
    }
  },
  activated() {
    window.addEventListener('resize', this.getHeight)
    this.getHeight()
    this.getEncodingRules()
    this.getCodeMenuSelect()
  },
  created() {
    this.getEncodingRules()
  },
  mounted() {
    window.addEventListener('resize', this.getHeight)
    this.getHeight()

    this.getCodeMenuSelect()
  },
  methods: {
    async getCodeMenuSelect() {
      const { data: res } = await CodeMenuSelect()
      this.menuOptionsAll = arrayToTree(res, {
        parentProperty: 'parent_id',
        customID: 'menucode',
        childrenProperty: 'children'
      })
      // this.menuOptions = this.menuOptionsAll.filter(i => i.Type === this.dialogForm.type)
    },
    radioChange() {
      this.menuOptions = this.menuOptionsAll.filter(i => i.Type === this.dialogForm.type)
    },
    async getEncodingRules() {
      const res = await EncodingRules(this.form)
      this.tableData = res.data
      this.total = res.count
    },
    // 排序改变时
    sortChange({ column, prop, order }) {
      if (order === 'descending') {
        order = 'desc'
      } else if (order === 'ascending') {
        order = 'asc'
      } else {
        order = 'desc'
      }
      this.form.order = order
      this.form.prop = prop
      this.getEncodingRules()
    },
    // 重置
    reset() {
      this.form.rightname = ''
      this.form.prefix = ''
      this.getEncodingRules()
    },
    // 新增按钮
    add(operation) {
      this.operation = operation
      this.dialogVisible = true
    },
    // 修改按钮
    edit(operation, row) {
      this.operation = operation
      this.dialogVisible = true

      this.$nextTick(() => {
        this.dialogForm.type = row.Type
        this.radioChange()

        let parentCode = ''
        this.menuOptions.forEach(item => {
          if (item.children && item.children.length) {
            item.children.forEach(it => {
              if (it.menucode === row.menucode) {
                parentCode = it.parent_id
              }
            })
          }
        })
        console.log(parentCode, row.menucode)
        this.$refs.cascader.checkedValue = [parentCode, row.menucode]
        this.dialogForm.rightcode = row.menucode
        this.dialogForm.incbit = row.incbit
        this.dialogForm.filingdate = row.filingdate
        this.dialogForm.prefix = row.prefix
      })
    },
    // 删除按钮
    async del(row) {
      this.$confirm('是否确认删除?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        DeleteEncodingRules({ menucode: row.menucode }).then(res => {
          if (res.code === '200') {
            this.$notify.success('删除成功!')
            if (this.form.page > 1 && this.tableData.length === 1) {
              this.form.page--
            }
            this.getEncodingRules()
          }
        })
      }).catch(() => {
        this.$notify.info('已取消删除')
      })
    },
    // 对话框关闭事件
    handleClose() {
      this.dialogForm.rightcode = ''
      this.dialogForm.rightname = ''
      this.dialogForm.incbit = '1'
      this.dialogForm.filingdate = ''
      this.dialogForm.prefix = ''
      this.$refs.cascader.checkedValue = ''
      this.$refs.dialogForm.clearValidate()
    },
    // 对话框取消
    dialogVisibleCancel() {
      this.dialogVisible = false
    },
    // 对话框确认
    dialogVisibleConfirm() {
      this.$refs.dialogForm.validate(valid => {
        if (valid) {
          this.$store.state.app.buttonIsDisabled = true
          const rightcode = this.$refs.cascader.checkedValue[this.$refs.cascader.checkedValue.length - 1]
          this.dialogForm.rightcode = rightcode
          this.dialogForm.rightname = this.menuOptions[this.menuOptions.findIndex(i => i.menucode === this.$refs.cascader.checkedValue[0])].children.find(i => i.menucode === rightcode).menuname
          SaveEncodingRules(this.dialogForm).then(res => {
            if (res.code === '200') {
              this.$notify.success(this.operation === 'add' ? '添加成功！' : '修改成功！')
              this.dialogVisible = false
              this.$store.state.app.buttonIsDisabled = false
              this.getEncodingRules()
            } else {
              this.$store.state.app.buttonIsDisabled = false
              this.$notify.error(this.operation === 'add' ? '添加失败！' : '修改失败！')
            }
          })
        }
      })
    },
    // 获取页面高度
    getHeight() {
      this.$nextTick(() => {
        this.mainHeight = window.innerHeight - 85
        this.tableHeight = this.mainHeight - 240
        this.$refs.tableDataRef.doLayout()
      })
    }
  }
}
</script>
